package jp.ne.xuni.seleneserver;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.Reader;

public class InstantBufferedReader extends BufferedReader {
	private String separator = System.getProperty("line.separator");

	public InstantBufferedReader(Reader in) {
		super(in);
	}
	public InstantBufferedReader(Reader in, int sz) {
		super(in, sz);
	}

	public String readTo(int end) throws IOException {
		String line;
		StringBuffer sb = new StringBuffer();
		for (int i = 0; i < end && (line = readLine()) != null; i++) {
			sb.append(line);
			sb.append(separator);
		}
		return sb.toString();
	}
	public String readToEnd() throws IOException {
		return readTo(Integer.MAX_VALUE);
	}
}
