package jp.ne.xuni.selene;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import org.eclipse.core.resources.IStorage;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.PlatformObject;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.IPersistableElement;

public class FetchedDocument extends PlatformObject
	implements IStorage, IPersistableElement {
	protected String document;
	protected SearchResult info;

	public FetchedDocument(String document, SearchResult info) {
		this.document = document;
		this.info = info;
	}

	public int hashCode() {
		return getFullPath().toString().hashCode();
	}
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		return (obj instanceof FetchedDocument) ?
			((FetchedDocument)obj).getFullPath().toString().
				equals(getFullPath().toString()) :
			false;
	}

	public String getDocument() {
		return document;
	}
	public SearchResult getInfo() {
		return info;
	}

	public InputStream getContents() {
		return new ByteArrayInputStream(document.getBytes());
	}
	public IPath getFullPath() {
		return info.getPath();
	}
	public String getName() {
		return info.getPath().lastSegment();
	}
	public boolean isReadOnly() {
		return true;
	}

	public void saveState(IMemento memento) {
		memento.putTextData(document);
		info.saveState(memento.createChild("searchResult"));
	}

	public String getFactoryId() {
		return SelenePlugin.PLUGIN_ID + ".inputFactory";
	}
}
