package jp.ne.xuni.selene;

import org.eclipse.ui.IMemento;

public class ZippedSearchResult extends SearchResult {
	public static final String SEPARATOR = " -:zip:- ";

	private String archive;

	public ZippedSearchResult() {
	}
	public ZippedSearchResult(double weight,
		String host, String repository, String name, String archive) {
		super(weight, host, repository, name);
		this.archive = archive;
	}
	public ZippedSearchResult(SearchResult sr, String archive) {
		this(sr.getWeight(), sr.getHost(), sr.getRepository(), sr.getName(),
			archive);
	}
	public ZippedSearchResult(double weight,
		String host, String repository, String name) {
		super(weight, host, repository, name);

		int indexOfSeparator = name.lastIndexOf(SEPARATOR);
		if (indexOfSeparator != -1) {
			setName(name.substring(0, indexOfSeparator));
			archive = name.substring(indexOfSeparator + SEPARATOR.length());
		}
	}

	public void setArchive(String archive) {
		this.archive = archive;
	}

	public String getArchive() {
		return archive;
	}

	public void saveState(IMemento memento) {
		super.saveState(memento);
		memento.putString("archive", archive);
	}

	public static ZippedSearchResult createElement(IMemento memento) {
		return memento == null ? new ZippedSearchResult() :
			new ZippedSearchResult(SearchResult.createElement(memento),
			memento.getString("archive"));
	}
}
