package jp.ne.xuni.selene.views;

import jp.ne.xuni.selene.FetchedDocument;

import org.eclipse.core.resources.IStorage;
import org.eclipse.core.runtime.PlatformObject;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IPersistableElement;
import org.eclipse.ui.IStorageEditorInput;
import org.eclipse.ui.PlatformUI;

public class FetchedEditorInput extends PlatformObject
	implements IStorageEditorInput {
	private FetchedDocument input;

	public FetchedEditorInput(FetchedDocument input) {
		this.input = input;
	}

	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		return (obj instanceof FetchedEditorInput) ?
			((FetchedEditorInput)obj).input.equals(input) :
			false;
	}

	public boolean exists() {
		return true;
	}
	public ImageDescriptor getImageDescriptor() {
		return PlatformUI.getWorkbench().getEditorRegistry().
			getDefaultEditor(getName()).getImageDescriptor();
	}
	public String getName() {
		return input.getName();
	}
	public IPersistableElement getPersistable() {
		return input;
	}
	public String getToolTipText() {
		return input.getFullPath().toString();
	}

	public IStorage getStorage() {
		return input;
	}
}
